// $ segédfüggvény
function $(selector) {
  return document.querySelector(selector);
}

// segedfüggvény korábbi feladatból
function veletlenEgesz(min, max) {
  const veletlen = Math.random();
  const tartomany = max - min + 1;
  return Math.trunc(veletlen * tartomany) + min;
}

const szelesseg = 500;
const magassag = 500;
const g = 9.82; // a gravitációs gyorsulás
const frissitesiIdo = 1000 / 60; // másodpercenként 60 frissítés

const vaszon = $("canvas");
const rajz = vaszon.getContext("2d");
vaszon.width = szelesseg;
vaszon.height = magassag;

// ÁLLAPOT
let hopelyhek; // hópelyhek tömbje
// egy hópelyhet egy {x, y} koordináta ír le
let lepesSzam; // az eddigi szimulációs lépések száma

function kirajzol() {
  rajz.clearRect(0, 0, szelesseg, magassag); // a vászon törlése
  rajz.fillStyle = "gray";
  rajz.fillRect(0, 0, szelesseg, magassag); // háttérszín
  // végigmegyünk a hópelyheken
  for (let hopehely of hopelyhek) {
    // kirajzolunk egy hópelyhet
    rajz.beginPath();
    rajz.fillStyle = "white";
    rajz.arc(hopehely.x, hopehely.y, 5, 0, Math.PI * 2); // 5 px sugarú fehér kör (x;y)-ba
    rajz.fill();
    rajz.closePath();
  }
}
function kovetkezoAllapot() {
  // eltelt idő a legutóbbi állapot óta másodpercben
  const dt = frissitesiIdo / 1000;
  // végigmegyünk a hópelyheken
  for (let hopehely of hopelyhek) {
    // ha még nem ért le
    if (hopehely.y < magassag - 2) {
      hopehely.y += hopehely.vy * dt + (g / 2 * dt * dt);
      hopehely.vy += g * dt;
    }
  }
  if (lepesSzam % 50 == 0) { // minden ötvenedik lépésben...
    ujHopehely(); // létrehozunk egy új hópelyhet
  }
  kirajzol();
}

function kezdoAllapot() {
  lepesSzam = 0; // lenullázzuk a lépésszámot
  hopelyhek = []; // kezdetben nincsnenk hopelyhek
  kirajzol();
}

function ujHopehely() {
  // létrehozunk egy új hópelyhet
  hopelyhek.push({
    x: veletlenEgesz(0, szelesseg),
    y: 0,
    vy: 0
  });
}

kezdoAllapot();
setInterval(kovetkezoAllapot, frissitesiIdo);